repos:
  - repo: https://github.com/pre-commit/pre-commit-hooks
    rev: v4.4.0
    hooks:
      - id: check-yaml
        args: [--unsafe]
      - id: end-of-file-fixer
      - id: trailing-whitespace
        exclude: ^docs/

  - repo: https://github.com/pre-commit/pre-commit
    rev: v3.1.1
    hooks:
      - id: validate_manifest

  - repo: https://github.com/python-poetry/poetry
    rev: 1.5.1
    hooks:
      - id: poetry-check
      - id: poetry-lock
      - id: poetry-export
        args: [--format, requirements.txt, --output, requirements.txt]

  - repo: https://github.com/awslabs/git-secrets
    rev: 5357e18bc27b42a827b6780564ea873a72ca1f01 # master branch as of 6/20/2023. Most recent tag (1.3.0) does not contain pre-commit hooks
    hooks:
      - id: git-secrets

  - repo: https://github.com/psf/black
    rev: 23.7.0
    hooks:
      - id: black
        always_run: true
        args: [--config, pyproject.toml, hoppr, test/unit]

  - repo: https://github.com/PyCQA/isort
    rev: 5.12.0
    hooks:
      - id: isort
        always_run: true
        args: [--settings, pyproject.toml, hoppr, test/unit]

  - repo: https://github.com/sourcery-ai/sourcery
    rev: v1.6.0
    hooks:
      - id: sourcery
        args: [--diff=git diff HEAD, --no-summary]

  - repo: local
    hooks:
      - id: mypy
        name: mypy
        entry: poetry run mypy --install-types --non-interactive
        pass_filenames: false
        language: system

      - id: pylint
        name: pylint
        entry: poetry run pylint hoppr test/unit
        pass_filenames: false
        language: system

      - id: pytest
        name: pytest
        entry: poetry run pytest
        pass_filenames: false
        language: system
